//---------------------------------------------------------------------------
//
//   Snap2Near
//
//          Copyright(C) 2022, Tark
//
//     I𒸓_ċߐڒ_֓ꉻXibv
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <sstream>
#include "MQPlugin.h"
#include "CMQObject.h"
#include "Snap2Near.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void Snap2Near::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID = 0xBD9A188A;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *Snap2Near::GetPlugInName(void)
{
	// vOC
	return "Snap2Near ver.1.0 Copyright(C) 2022, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const wchar_t *Snap2Near::EnumString(int index)
{
	switch(index){
	case 0: return L"Snap2Near(Current)"; break;
	case 1: return L"Snap2Near(Other)"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static Snap2Near plugin;
	return &plugin;
}

BOOL Snap2Near::Execute(int index, MQDocument doc_)
{
	doc = cmq::CMQDocument(doc_);
	switch (index){
	case 0:
	case 1:
		return main(doc, index);
	}
	return FALSE;
}

Snap2Near::Snap2Near() : doc(nullptr)
{
}

Snap2Near::~Snap2Near()
{
}

BOOL Snap2Near::main(cmq::CMQDocument &doc, int index)
{
	cmq::CMQObject cur = doc.getCurrentObject();

	bool selected = false;
	cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer(&cur);
	for (auto vit = vcontainer.begin(); vit != vcontainer.end(); ++vit) {
		if (vit->isSelect()) {
			selected = true;
			break;
		}
	}
	if (!selected) {
		// I𒸓_Ȃꍇ͉Ȃ
		return FALSE;
	}

	if(index == 0) {
		// JgIuWFNg̔I𒸓_̂ł߂_փXibv
		cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer1(&cur);
		for (auto vit1 = vcontainer1.begin(); vit1 != vcontainer1.end(); ++vit1) {
			if (!vit1->isSelect()) {
				continue;
			}
			MQPoint p1 = vit1->p();
			float mindist = FLT_MAX;
			cmq::vindex_t target = -1;
			cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer2(&cur);
			for (auto vit2 = vcontainer2.begin(); vit2 != vcontainer2.end(); ++vit2) {
				if (vit2->isSelect()) {
					continue;
				}
				MQPoint p2 = vit2->p();
				float dist = (p2 - p1).norm();
				if (dist < mindist) {
					mindist = dist;
					target = vit2.index();
				}
			}
			if (target != -1) {
				cur.setVertex(vit1.index(), cur.getVertex(target));
			}
		}
	}
	else {
		// JgIuWFNgȊO̔\łȂIuWFNg̍ł߂_փXibv
		cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer1(&cur);
		for (auto vit1 = vcontainer1.begin(); vit1 != vcontainer1.end(); ++vit1) {
			if (!vit1->isSelect()) {
				continue;
			}
			float mindist = FLT_MAX;
			cmq::vindex_t target = -1;
			cmq::oindex_t target_obj = -1;
			MQPoint p1 = vit1->p();
			for (cmq::oindex_t oindex = 0; oindex < doc.getObjectCount(); oindex++) {
				cmq::CMQObject obj(doc.getObject(oindex));
				if(!obj.isLive() || !obj.getVisible() || obj == cur) {
					continue;
				}
				cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer2(&obj);
				for (auto vit2 = vcontainer2.begin(); vit2 != vcontainer2.end(); ++vit2) {
					MQPoint p2 = vit2->p();
					float dist = (p2 - p1).norm();
					if (dist < mindist) {
						mindist = dist;
						target = vit2.index();
						target_obj = oindex;
					}
				}
			}
			if (target != -1) {
				auto obj = doc.getObject(target_obj);
				auto p = obj.getVertex(target);
				cur.setVertex(vit1.index(), p);
			}
		}
	}
	return TRUE;
}
